module TryCatch

  EXT= Module.new
  module EXT::Object

    #> return ex and cache
    def __try__ *exception_classes, &block
      ::TryCatch::Function.try( self, *exception_classes, &block )
    end

    #> return ex but not cache
    def __try_nc__ *exception_classes, &block
      ::TryCatch::Function.try_no_cache( *exception_classes, &block )
    end

    #> return nil if fail
    def __try_nil__ *exception_classes, &block
      ::TryCatch::Function.try?( *exception_classes, &block )
    end
    alias __try_n__ __try_nil__

    #> catch from cach or on self obj
    def __catch__ *exception_classes, &block
      ::TryCatch::Function.catch self, *exception_classes, &block
    end

  end

end

Object.__send__ :include, TryCatch::EXT::Object
